<?php
/**
* NOTICE OF LICENSE
*
* This source file is the property of Conexiaweb
* that is bundled with this package.
* It is also available through the world-wide-web at this URL:
*  Conexiaweb.es
*  @author conexiaweb.es <info@conexiaweb.es>
*  @copyright  2020  Conexiaweb.es
*  @license    http://conexiaweb.es
*  Great!!!    http://transfertomalaga.es | http://transfertocordoba.es | http://transfertomarbella.com/ | http://transfervalladolid.es/ | http://transfertosevilla.es/ | http://transfertogranada.es/ | http://transfertorremolinos.es/ | http://transferfuengirola.es/ | http://transferbenalmadena.es/ | http://transfertomarbella.com/ | http://transfertonerja.es/ | http://transfertomijas.es/ | http://transfertorredelmar.es/ | http://laborser.es | http://multiserviciosencordoba.es
*/

class HideCategoryText extends Module
{
    
    public function __construct()
    {
        $this->name = 'hidecategorytext';
        $this->tab = 'front_office_features';
        $this->version = '1.0.0';
        $this->author = 'Conexiaweb';
        $this->dir = '/modules/hidecategorytext/';
        $this->bootstrap = true;

        parent::__construct();

        $this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Leer más en Categorías PS 1.7');
        $this->description = $this->l('Podrás ocultar descripciones largas de categorías poniendo leer más');
        $this->confirmUninstall = $this->l('¿Seguro que quieres borrar este módulo?');
    }

    public function install()
    {
        return parent::install() &&
            Configuration::updateValue('HIDE_CATEGORY_HEIGHT', '200') &&
            Configuration::updateValue('HIDE_CATEGORY_RM', 'Leer más') &&
            Configuration::updateValue('HIDE_CATEGORY_RL', 'Ocultar') &&
            $this->registerHook('actionFrontControllerSetMedia');
    }

    public function uninstall()
    {
        return Configuration::deleteByName('HIDE_CATEGORY_HEIGHT') &&
        Configuration::deleteByName('HIDE_CATEGORY_RM') &&
        Configuration::deleteByName('HIDE_CATEGORY_RL') &&
        parent::uninstall();
    }

    public function hookActionFrontControllerSetMedia()
    {
        $this->page_name = Dispatcher::getInstance()->getController();
        if ($this->page_name == 'category') {
            Media::addJsDef(array(
                "catHeight" => (int)Configuration::get('HIDE_CATEGORY_HEIGHT'),
                "readMore" => Configuration::get('HIDE_CATEGORY_RM'),
                "readLess" => Configuration::get('HIDE_CATEGORY_RL'),
            ));

            $this->context->controller->registerJavascript('modules-hidecategorytext-lib', 'modules/'.$this->name.'/views/js/readmore.min.js', ['position' => 'bottom', 'priority' => 150]);
            $this->context->controller->registerJavascript('modules-hidecategorytext-js', 'modules/'.$this->name.'/views/js/hidecategorytext.js', ['position' => 'bottom', 'priority' => 150]);
        }
    }
	

    public function getContent()
    {
        $html = '';

        if (Tools::isSubmit('submitModule')) {
            Configuration::updateValue('HIDE_CATEGORY_HEIGHT', Tools::getValue('HIDE_CATEGORY_HEIGHT'));
            Configuration::updateValue('HIDE_CATEGORY_RM', Tools::getValue('HIDE_CATEGORY_RM'));
            Configuration::updateValue('HIDE_CATEGORY_RL', Tools::getValue('HIDE_CATEGORY_RL'));

            $html .= $this->displayConfirmation($this->l('Configuration updated.'));
        }

        $html .= $this->renderForm();
        return $html;
    }

    public function renderForm()
    {
        
        $fields_form = array(
        'form' => array(
            'legend' => array(
                'title' => $this->l('Settings'),
                'icon' => 'icon-cogs'
                ),
            'input' => array(
                array(
                    'type' => 'text',
                    'label' => $this->l('Ancho del texto de la Categoría'),
                    'name' => 'HIDE_CATEGORY_HEIGHT',
                    'desc' => $this->l('Define el ancho en px')
                    ),
                array(
                    'type' => 'text',
                    'label' => $this->l('Etiqueta de leer más'),
                    'name' => 'HIDE_CATEGORY_RM',
                    'desc' => $this->l('Introduce la palabra de "Leer más"')
                    ),
                array(
                    'type' => 'text',
                    'label' => $this->l('Etiqueta Ocultar'),
                    'name' => 'HIDE_CATEGORY_RL',
                    'desc' => $this->l('Introduce la palabra de "Ocultar"')
                    ),
                ),
            'submit' => array(
                'title' => $this->l('Save')
                )
            ),
        );

        $helper = new HelperForm();
        $helper->show_toolbar = false;
        $helper->table =  $this->table;
        $lang = new Language((int)Configuration::get('PS_LANG_DEFAULT'));
        $helper->default_form_language = $lang->id;
        $helper->allow_employee_form_lang = Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') ? Configuration::get('PS_BO_ALLOW_EMPLOYEE_FORM_LANG') : 0;
        $this->fields_form = array();

        $helper->identifier = $this->identifier;
        $helper->submit_action = 'submitModule';
        $helper->currentIndex = $this->context->link->getAdminLink('AdminModules', false).'&configure='.$this->name.'&tab_module='.$this->tab.'&module_name='.$this->name;
        $helper->token = Tools::getAdminTokenLite('AdminModules');
        $helper->tpl_vars = array(
            'fields_value' => $this->getConfigFieldsValues(),
            'languages' => $this->context->controller->getLanguages(),
            'id_language' => $this->context->language->id
            );

        return $helper->generateForm(array($fields_form));
    }

    public function getConfigFieldsValues()
    {
        return array(
            'HIDE_CATEGORY_HEIGHT' => Tools::getValue('HIDE_CATEGORY_HEIGHT', Configuration::get('HIDE_CATEGORY_HEIGHT')),
            'HIDE_CATEGORY_RM' => Tools::getValue('HIDE_CATEGORY_RM', Configuration::get('HIDE_CATEGORY_RM')),
            'HIDE_CATEGORY_RL' => Tools::getValue('HIDE_CATEGORY_RL', Configuration::get('HIDE_CATEGORY_RL')),
        );
    }
}
